%MACRO DISP2;
%MACRO WINDISP2;
DATA _NULL_;
WINDOW MDISP2 COLOR=grey
#1 "DISSOLUTION ACCEPTANCE LIMIT PROGRAM" C=yellow
#2 "FOR SAMPLING PLAN 2 (GREATER THAN ONE SAMPLE PER LOCATION)" C=yellow
#4  "ENTER Q:  " C=blue Q 4.1 A=UNDERLINE
#5  "ENTER NUMBER OF LOCATIONS:  " C=blue LOC 4.0 A=UNDERLINE
#6  "ENTER NUMBER PER LOCATION:  " C=blue NUM 4.0 A=UNDERLINE
#9 "ENTER BOUND ON FUTURE PERCENTAGE PASSING (50.0-99.0):  " C=blue
    LBOUND 4.1 A=UNDERLINE
#10 "ENTER CONFIDENCE LEVEL (50.0-99.0):  " C=blue CILEVEL 4.1 A=UNDERLINE
#12 "ENTER INCREMENT FOR SE:  " C=blue DSE  4.2 A=UNDERLINE
#13 "ENTER INCREMENT FOR BETWEEN LOCATION STD DEV:  " C=blue DSM 4.2
     A=UNDERLINE
#15 "DO YOU WANT TO PRINT THE ACCEPTANCE LIMIT TABLE?" C=BLUE
#16 "ENTER Y OR N ="  C=BLUE A1DISP2 $1.
#18 "DO YOU WANT TO EVALUATE THE ACCEPTANCE LIMIT TABLE?" C=BLUE
#19 "ENTER Y OR N ="  C=BLUE A2DISP2 $1.
#21 "DO YOU WANT THE LOWER BOUND FOR A SPECIFIC SAMPLE RESULT?" C=BLUE
#22 "ENTER Y OR N ="  C=BLUE A3DISP2 $1.;
WINDOW DSESM COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "THE INCREMENT FOR SE AND BETWEEN LOCATION STD DEV" C=YELLOW
#2 "MUST BE GREATER THAN ZERO" C=YELLOW
#3 "(TYPICAL VALUES ARE 0.1, 0.2, 0.25, OR 0.50)" C=YELLOW
#5 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW DILOCAT COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS= 10 IROW=5
#1 "NUMBER OF LOCATIONS MUST BE AN INTEGER GREATER THAN 2" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW DINUMB COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS= 10 IROW=5
#1 "NUMBER PER LOCATION MUST BE AN INTEGER GREATER THAN 1" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW BDISP2 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "THE LOWER BOUND ON THE PERCENTAGE OF ALL FUTURE BATCHES" C=YELLOW
#2 "PASSING THE USP TEST MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#3 "(TYPICAL VALUES ARE 50.0 AND 95.0)" C=YELLOW
#5 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW QDISP2 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "VALUES FOR Q MUST BE BETWEEN 40 AND 95" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW CIDISP2 COLOR=RED
    COLUMNS=60 ICOLUMN=10 ROWS=10 IROW=5
#1 "CONFIDENCE INTERVAL VALUES MUST BE BETWEEN 50.0 AND 99.0" C=YELLOW
#2 "(TYPICAL VALUES ARE 90.0, 95.0, OR 99.0)" C=YELLOW
#4 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW ANSDISP2 COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "REQUEST REQUIRES A RESPONSE OF: Y OR N" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
LOC=10;
NUM=6;
Q=80;
DSE = 0.25;
DSM = 0.25;
LBOUND = 95;
CILEVEL = 95;
A1DISP2 = 'Y';
A2DISP2 = 'N';
A3DISP2 = 'N';
MAINDI2:
DISPLAY MDISP2 BELL;
IF LOC LE 2 OR LOC NE ROUND(LOC) THEN DO;
DISPLAY DILOCAT BELL;
GOTO MAINDI2;
END;
IF NUM LE 1 OR NUM NE ROUND(NUM) THEN DO;
DISPLAY DINUMB BELL;
GOTO MAINDI2;
END;
IF Q GT 95.0 OR Q LT 40.0 THEN DO;
DISPLAY QDISP2 BELL;
GOTO MAINDI2;
END;
IF DSE LE 0 OR DSM LE 0 THEN DO;
DISPLAY DSESM BELL;
GOTO MAINDI2;
END;
IF LBOUND GT 99.0 OR LBOUND LT 50.0 THEN DO;
DISPLAY BDISP2 BELL;
GOTO MAINDI2;
END;
IF CILEVEL GT 99.0 OR CILEVEL LT 50.0 THEN DO;
DISPLAY CIDISP2 BELL;
GOTO MAINDI2;
END;
IF A1DISP2 NE 'Y' AND A1DISP2 NE 'N' AND
   A1DISP2 NE 'y' AND A1DISP2 NE 'n' THEN DO;
DISPLAY ANSDISP2 BELL;
GOTO MAINDI2;
END;
IF A2DISP2 NE 'Y' AND A2DISP2 NE 'N' AND
   A2DISP2 NE 'y' AND A2DISP2 NE 'n' THEN DO;
DISPLAY ANSDISP2 BELL;
GOTO MAINDI2;
END;
IF A3DISP2 NE 'Y' AND A3DISP2 NE 'N' AND
   A3DISP2 NE 'y' AND A3DISP2 NE 'n' THEN DO;
DISPLAY ANSDISP2 BELL;
GOTO MAINDI2;
END;
CALL SYMPUT("Q",PUT(Q,4.1));
CALL SYMPUT("DSE",PUT(DSE,4.2));
CALL SYMPUT("DSM",PUT(DSM,4.2));
CALL SYMPUT("A1DISP2",PUT(UPCASE(A1DISP2),$1.));
CALL SYMPUT("A2DISP2",PUT(UPCASE(A2DISP2),$1.));
CALL SYMPUT("A3DISP2",PUT(UPCASE(A3DISP2),$1.));
CALL SYMPUT("LOC",PUT(LOC,4.0));
CALL SYMPUT("NUM",PUT(NUM,4.0));
CALL SYMPUT("LBOUND",PUT(LBOUND,4.1));
CALL SYMPUT("CILEVEL",PUT(CILEVEL,4.1)); STOP;
RUN;

%MEND WINDISP2;

OPTIONS NODATE NONUMBER;
%MACRO COMPUTE;
   F1 = (1 - PROBNORM((5 - LLU)/SIGMA)) ** 6;
   SN2 = SQRT(12);
   PM2 = PROBNORM (SN2 * -LLU / SIGMA);
   PB2 = 1 - PROBNORM ((-LLU - 15) / SIGMA);
   F2 = PB2 ** 12 - PM2;
   SN3 = SQRT(24);
   PM3 = PROBNORM (SN3 * -LLU / SIGMA);
   P2 = PROBNORM ((-LLU - 15) / SIGMA) - PROBNORM ((-LLU - 25) / SIGMA);
   P3 = 1 - PROBNORM ((-LLU - 15) / SIGMA);
   F3 = P3**24 + 24*P2*P3**23 + 276*P2*P2*P3**22 - PM3;
   OVERBD = MAX(F1, F2, F3);
%mend compute;



%MACRO CALDISP2;
DATA TABD;
   DM =0.10;
   DSE = &DSE;
   DSM = &DSM;
   Q = &Q;
   LIM = 100 - Q;
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   CALL SYMPUT("TOT",PUT(N, 5.0));
   Z = PROBIT(SQRT(&CILEVEL / 100));
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SEBOUND = 60;
   SMLIM = 60;
   NEXTM = 0.2;
  DO SE = DSE TO SEBOUND BY DSE;
   MEANL = NEXTM;
   SMBOUND = SMLIM;
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
  DO SM = DSM TO SMBOUND BY DSM;
   IF MEANL =. THEN GOTO OVER;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
   DO MEANADJ = MEANL TO LIM BY DM;
   LLU = MEANADJ - Z *SQRT(MVAR / N);
%COMPUTE
   IF OVERBD > &LBOUND/100 THEN DO;
     MEANL = MEANADJ;
     GOTO SKIP;
                                END;
   END;
    MEANL =.;
 IF SE=DSE THEN DO;
   SMLIM = SM - DSM;
   MEAN = MEANL + Q;
   OUTPUT;
   SM = 90;
   GOTO OVER;
                END;
 IF SM=DSM THEN DO; SE = 90; GOTO OVER; END;
SKIP:
   MEAN = MEANL + Q;
   OUTPUT;
IF SM = DSM THEN NEXTM = MEANL;
OVER:
  END;
 END;
KEEP N NN L MEAN SE SM OVERBD;
PROC SORT DATA=TABD; BY SE SM;


%MEND CALDISP2;

%MACRO PRTDISP2;
options ls=132;

PROC TABULATE DATA=TABD FORMAT=6.2 FORMCHAR='          ';
  CLASS SE SM;
  FORMAT SE 6.2 SM 6.2;
  VAR MEAN;
  TABLE SE, SUM*MEAN = ' ' * (SM = ' ')/rts=8;
  KEYLABEL SUM = 'STANDARD DEVIATION OF LOCATION MEANS';
TITLE "ACCEPTANCE LIMITS FOR DISSOLUTION (Q = &Q) ";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "LOWER BOUND = &LBOUND, CONFIDENCE LEVEL = &CILEVEL";
TITLE4 'TABLE ENTRIES ARE LOWER LIMITS ON THE MEAN';
TITLE5 "OF &TOT ASSAYS-&NUM ASSAYS AT EACH OF &LOC DIFFERENT LOCATIONS";
TITLE6 'SE IS THE POOLED WITHIN LOCATION STANDARD DEVIATION';
TITLE7 'STANDARD DEVIATIONS AND MEANS ARE EXPRESSED IN % CLAIM';
run;

%MEND PRTDISP2;


%MACRO EVDISP2;

DATA _NULL_; WINDOW SMAIN COLOR=GREY
#1 "TO EVALUATE LIMITS, THE USER MUST SPECIFY THE RANGE OF" C=yellow
#2 "POSSIBLE POPULATION VALUES FOR THE MEAN, WITHIN LOCATION" C=yellow
#3 "STD DEV AND BETWEEN LOCATION STD DEV" C=yellow
#5 "ENTER ALL VALUES AS POSITIVE INTEGERS" C=yellow
#7  "ENTER LOWER BOUND FOR MEAN:            " C=blue ULOW 4.0
    A=UNDERLINE
#8  "ENTER UPPER BOUND FOR MEAN:            " C=blue UHIGH 4.0
    A=UNDERLINE
#9  "ENTER INCREMENT FOR MEAN:              " C=blue UINCRE 4.0
    A=UNDERLINE
#10 "ENTER DIVISOR FOR MEAN:                " C=blue UDIV 4.0
    A=UNDERLINE
#12 "ENTER LOWER BOUND FOR WITHIN STD DEV:  " C=blue SELOW 4.0
    A=UNDERLINE
#13 "ENTER UPPER BOUND FOR WITHIN STD DEV:  " C=blue SEHIGH 4.0
    A=UNDERLINE
#14 "ENTER INCREMENT FOR WITHIN STD DEV:    " C=blue SEINCRE 4.0
    A=UNDERLINE
#15 "ENTER DIVISOR FOR WITHIN STD DEV:      " C=blue SEDIV 4.0
    A=UNDERLINE
#17 "ENTER LOWER BOUND FOR BETWEEN STD DEV: " C=blue SMLOW 4.0
    A=UNDERLINE
#18 "ENTER UPPER BOUND FOR BETWEEN STD DEV: " C=blue SMHIGH 4.0
    A=UNDERLINE
#19 "ENTER INCREMENT FOR BETWEEN STD DEV:   " C=blue SMINCRE 4.0
    A=UNDERLINE
#20 "ENTER DIVISOR FOR BETWEEN STD DEV:     " C=blue SMDIV 4.0
    A=UNDERLINE;
WINDOW DI2PINT COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ALL VALUES MUST BE POSITIVE INTEGERS" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW DI2ORD  COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ERROR: UPPER BOUND IS LESS THAN LOWER BOUND" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
ULOW=950;
UHIGH=1000;
UINCRE=50;
UDIV=10;
SELOW=22;
SEHIGH=22;
SEINCRE=10;
SEDIV=10;
SMLOW=22;
SMHIGH=22;
SMINCRE=10;
SMDIV=10;
MAINDI2:
DISPLAY SMAIN BELL;
IF ULOW LT 1 OR ROUND(ULOW) NE ULOW
OR UHIGH LT 1 OR ROUND(UHIGH) NE UHIGH
OR UINCRE LT 1 OR ROUND(UINCRE) NE UINCRE
OR UDIV LT 1 OR ROUND(UDIV) NE UDIV
OR SELOW LT 1 OR ROUND(SELOW) NE SELOW
OR SEHIGH LT 1 OR ROUND(SEHIGH) NE SEHIGH
OR SEINCRE LT 1 OR ROUND(SEINCRE) NE SEINCRE
OR SEDIV LT 1 OR ROUND(SEDIV) NE SEDIV
OR SMLOW LT 1 OR ROUND(SMLOW) NE SMLOW
OR SMHIGH LT 1 OR ROUND(SMHIGH) NE SMHIGH
OR SMINCRE LT 1 OR ROUND(SMINCRE) NE SMINCRE
OR SMDIV LT 1 OR ROUND(SMDIV) NE SMDIV
THEN DO;
DISPLAY DI2PINT;
GOTO MAINDI2;
END;
IF ULOW GT UHIGH
OR SELOW GT SEHIGH
OR SMLOW GT SMHIGH
THEN DO;
DISPLAY DI2ORD;
GOTO MAINDI2;
END;
CALL SYMPUT("ULOW",PUT(ULOW,4.0));
CALL SYMPUT("UHIGH",PUT(UHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(UINCRE,4.0));
CALL SYMPUT("UDIV",PUT(UDIV,4.0));
CALL SYMPUT("SELOW",PUT(SELOW,4.0));
CALL SYMPUT("SEHIGH",PUT(SEHIGH,4.0));
CALL SYMPUT("SEINCRE",PUT(SEINCRE,4.0));
CALL SYMPUT("SEDIV",PUT(SEDIV,4.0));
CALL SYMPUT("SMLOW",PUT(SMLOW,4.0));
CALL SYMPUT("SMHIGH",PUT(SMHIGH,4.0));
CALL SYMPUT("SMINCRE",PUT(SMINCRE,4.0));
CALL SYMPUT("SMDIV",PUT(SMDIV,4.0)); STOP;
RUN;


%MACRO SIGDISP2;
%CALDISP2
   %DO U = &ULOW %TO &UHIGH %BY &UINCRE;
      %DO SIGSE = &SELOW %TO &SEHIGH %BY &SEINCRE;
         %DO SIGSM = &SMLOW %TO &SMHIGH %BY &SMINCRE;

  DATA SAVE2;
    SET TABD END = LAST;
   U = &U / &UDIV;
   DSE = &DSE;
   DSM = &DSM;
   SIGSE = &SIGSE / &SEDIV;
   SIGSM = &SIGSM / &SMDIV;
   SIGSM2 = SIGSM * SIGSM;
   EXPSE2 = SIGSE * SIGSE;
   EXPSM2 = EXPSE2 + NN * SIGSM * SIGSM;
   PMEAN = 1 - PROBNORM((MEAN - U) * SQRT((N) / EXPSM2));
   PSE = PROBCHI(L * (NN - 1) * SE * SE / EXPSE2, L * (NN -1))
         - PROBCHI(L * (NN - 1) * (SE - DSE) * (SE - DSE) /
         EXPSE2, L * (NN - 1));
   PSM = PROBCHI((L - 1) * NN * SM * SM / EXPSM2, L - 1)
         - PROBCHI((L - 1) * NN * (SM - DSM) * (SM - DSM) /
         EXPSM2, L - 1);
   P = PMEAN * PSE * PSM;
   PSUM + P;
   IF LAST THEN OUTPUT;
   RUN;
   PROC APPEND BASE = SAVES2E DATA = SAVE2;
   RUN;

       %END;
      %END;
     %END;

%MEND SIGDISP2;

%SIGDISP2

PROC PRINT DATA = SAVES2E split = '*';
  label U = 'MEAN'
       SIGSE = 'WITHIN LOCATION*STD DEV'
       SIGSM = 'BETWEEN LOCATION* STD DEV'
       PSUM = 'PROBABILITY*OF*PASSING';
   VAR U SIGSE SIGSM PSUM;
TITLE1 "ACCEPTANCE LIMITS FOR DISSOLUTION (Q = &Q) ";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "PROBABILITY OF PASSING DISSOLUTION ACCEPTANCE LIMIT TABLE";
TITLE4 "WITH &NUM ASSAYS AT EACH OF &LOC LOCATIONS";
TITLE5 "CONFIDENCE LEVEL = &CILEVEL & LOWER BOUND = &LBOUND";
RUN;
%MEND EVDISP2;

%MACRO SMPDISP2;

DATA _NULL_; WINDOW TMAIN COLOR=GREY
#3 "TO DETERMINE LOWER BOUND FOR FOUND SAMPLE RESULTS" C=yellow
#7  "ENTER SAMPLE MEAN (% CLAIM):            " C=blue MEAN 6.3 A=UNDERLINE
#9  "ENTER SAMPLE WITHIN STD DEV (% CLAIM):  " C=blue SE 6.3 A=UNDERLINE
#11 "ENTER SAMPLE BETWEEN STD DEV (% CLAIM): " C=blue SM 6.3 A=UNDERLINE
#12 "(I.E. STANDARD DEVIATION OF SAMPLE LOCATION MEANS)" C=blue;
WINDOW LTZ COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "ALL VALUES MUST BE NON NEGATIVE" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
WINDOW RANGE COLOR=RED
    COLUMNS=50 ICOLUMN=10 ROWS= 10 IROW=5
#1 "MEAN MUST BE GREATER THAN Q" C=YELLOW
#3 "PRESS ENTER TO CONTINUE" C=YELLOW;
MEAN=100.00;
SE=2.20;
SM=2.46;
TMAIN:
DISPLAY TMAIN BELL;
IF SM LE 0 OR SE LT 0
THEN DO;
DISPLAY LTZ;
GOTO TMAIN;
END;
IF MEAN LE &Q
THEN DO;
DISPLAY RANGE;
GOTO TMAIN;
END;
CALL SYMPUT("MEAN",PUT(MEAN,6.3));
CALL SYMPUT("SE",PUT(SE,6.3));
CALL SYMPUT("SM",PUT(SM,6.3)); STOP;
RUN;

DATA TAB;
   Z = PROBIT(SQRT(&CILEVEL/100));
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   SE = &SE;
   SM = &SM;
   MEAN = &MEAN;
   Q = &Q;
   MEANADJ = MEAN - Q;
   CILEVEL = &CILEVEL;
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
   LLU = MEANADJ - Z *SQRT(MVAR / N);
%COMPUTE
     KEEP SE MEAN SM OVERBD;
PROC PRINT SPLIT='*';
 LABEL   SE = 'SAMPLE*WITHIN LOCATION*STD DEV'
         MEAN = 'SAMPLE*MEAN'
         SM = 'SAMPLE*BETWEEN LOCATION*STD DEV'
         OVERBD = 'LOWER BOUND';
  ID MEAN;
  VAR SE SM OVERBD;
TITLE "ACCEPTANCE LIMITS FOR DISSOLUTION (Q = &Q) ";
TITLE2 "SAMPLING PLAN 2 (&LOC LOCATIONS, &NUM PER LOCATION)";
TITLE3 'PROPORTION OF FUTURE SAMPLES PASSING THE USP TEST';
TITLE4 "WITH &CILEVEL.% ASSURANCE";
TITLE5 'GIVEN THE SAMPLE MEAN, WITHIN AND BETWEEN STD DEV';
RUN;
%MEND SMPDISP2;

%MACRO ANADISP2;
    %WINDISP2;
%IF %UPCASE(&A1DISP2)=Y %THEN %DO;
     %CALDISP2;
     %PRTDISP2;
    %END;
%IF %UPCASE(&A2DISP2)=Y %THEN %DO;
      %EVDISP2;
PROC DATASETS LIBRARY=WORK;
   DELETE SAVES2E;
    %END;
%IF %UPCASE(&A3DISP2)=Y %THEN %DO;
     %SMPDISP2;
    %END;
%MEND ANADISP2;

%ANADISP2

RUN;
%MEND DISP2;
%DISP2
